#ifndef EFFECT_H
#define EFFECT_H

namespace eff {

/* Also update: Interface.cpp:specialEffectGlyph
   and NEUI.cpp:drawSpecialEffect */
enum type
{
    none,
    /* Most beam weapons use this. */
    laser_fw,
    laser_hz,
    laser_vt,
    laser_bw,
    laser,
    /* A variation of the above. */
    optic_fw,
    optic_hz,
    optic_vt,
    optic_bw,
    optic,
    /* Blaster bolts use this. */
    bolt_fw,
    bolt_hz,
    bolt_vt,
    bolt_bw,
    bolt,
    /* Packet storm (FTP daemon): */
    binary_fw,
    binary_hz,
    binary_vt,
    binary_bw,
    binary,
    /* Heat ray: */
    heat_fw,
    heat_hz,
    heat_vt,
    heat_bw,
    heat,
    /* Disintegration beam: */
    antimatter_fw,
    antimatter_hz,
    antimatter_vt,
    antimatter_bw,
    antimatter,
    /* Railgun: */
    rail_n,
    rail_ne,
    rail_e,
    rail_se,
    rail_s,
    rail_sw,
    rail_w,
    rail_nw,
    rail,
    /* Psi vomit: */
    psi_vomit_n,
    psi_vomit_ne,
    psi_vomit_e,
    psi_vomit_se,
    psi_vomit_s,
    psi_vomit_sw,
    psi_vomit_w,
    psi_vomit_nw,
    psi_vomit,
    /* Hydralisk spit: */
    hydra_n,
    hydra_ne,
    hydra_e,
    hydra_se,
    hydra_s,
    hydra_sw,
    hydra_w,
    hydra_nw,
    hydra,
    /* Combi-stick: */
    combi_n,
    combi_ne,
    combi_e,
    combi_se,
    combi_s,
    combi_sw,
    combi_w,
    combi_nw,
    combi_hz,
    combi_vt,
    combi_fw,
    combi_bw,
    /* Flame breath: */
    flame1,
    flame2,
    flame3,
    flame4,
    flame5,
    flame6,
    flame7,
    flame8,
    /* Bunch of single tile effects. */
    invis,
    pea,
    plasma,
    plasma_hit,
    boom,
    cold,
    poison,
    rad,
    blind,
    incendiary,
    psi_storm,
    disintegration,
    shrapnel,
    acid,
    vomit,
    water,
    web,
    /* Daemons' special attacks. */
    bugs,
    viruses,
    smart_disc,
    /* These are map markers. */
    radar_blip,     /* Generated by motion tracker. */
    sensed_life,    /* For sense life intrinsic. */
    sensed_tremor,  /* For tremorsense mutant power. */
    last_effect,
    /* Beam or ray corners.  They are last because console
       mode does not draw them, thus can skip defining them. */
    laser_nwc,
    laser_nec,
    laser_swc,
    laser_sec,
    optic_nwc,
    optic_nec,
    optic_swc,
    optic_sec,
    psi_vomit_nwc,
    psi_vomit_nec,
    psi_vomit_swc,
    psi_vomit_sec,
    binary_nwc,
    binary_nec,
    binary_swc,
    binary_sec,
    heat_nwc,
    heat_nec,
    heat_swc,
    heat_sec,
    antimatter_nwc,
    antimatter_nec,
    antimatter_swc,
    antimatter_sec,
    last_corner
};

}

struct Effect_on_map
{
    eff::type e;
    int x, y;
};

#endif
